#include <stdint.h>
#include <stdbool.h>
#include "inc/hw_types.h"
#include "inc/hw_memmap.h"
#include "driverlib/gpio.h"
#include "driverlib/sysctl.h"

// LED_/p}N
#define ON	0x00
#define OFF 0xFF

// LED_
void main(void) {
	// NbN̐ݒ
	SysCtlClockSet(SYSCTL_SYSDIV_1 | SYSCTL_USE_OSC | SYSCTL_OSC_MAIN | SYSCTL_XTAL_16MHZ);

	// gpytF̗L@LEDpIO|[gC, Dgp
	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOC);
	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOD);

	// PD0~PD3, PC4~PC7 o̓^Cvɐݒ
	GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, GPIO_PIN_0);
	GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, GPIO_PIN_1);
	GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, GPIO_PIN_2);
	GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, GPIO_PIN_3);
	GPIOPinTypeGPIOOutput(GPIO_PORTC_BASE, GPIO_PIN_4);
	GPIOPinTypeGPIOOutput(GPIO_PORTC_BASE, GPIO_PIN_5);
	GPIOPinTypeGPIOOutput(GPIO_PORTC_BASE, GPIO_PIN_6);
	GPIOPinTypeGPIOOutput(GPIO_PORTC_BASE, GPIO_PIN_7);

	// LEDON
	GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_0, ON);
	GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_1, OFF);
	GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_2, ON);
	GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_3, OFF);
	GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_4, ON);
	GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_5, OFF);
	GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_6, ON);
	GPIOPinWrite(GPIO_PORTC_BASE, GPIO_PIN_7, OFF);

	// [v
	while (1) {

	}
}
