#include <stdint.h>
#include <stdbool.h>
#include "inc/hw_types.h"
#include "inc/hw_memmap.h"
#include "driverlib/gpio.h"
#include "driverlib/sysctl.h"
#include "driverlib/adc.h"
#include "driverlib/pin_map.h"
#include "driverlib/pwm.h"

// DC[^PWM
void main(void) {
	// A/Dϊli[p
	uint32_t data;
	// ݒpϐ
	unsigned long ulPeriod;
	// ҂ԗp
	volatile unsigned long Loop;
	// NbN̐ݒ
	SysCtlClockSet(SYSCTL_SYSDIV_1 | SYSCTL_USE_OSC | SYSCTL_OSC_MAIN | SYSCTL_XTAL_16MHZ);

	// gpytF̗L
	// : AiÓAPWMo͂IO|[gE𗘗p
	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOE);
	// : A/DϊW[0𗘗p
	SysCtlPeripheralEnable(SYSCTL_PERIPH_ADC0);
	// : PWMW[0𗘗p
	SysCtlPeripheralEnable(SYSCTL_PERIPH_PWM0);

	// ADC̐ݒ
	// : PE3(AIN0)ADCɐݒ
	GPIOPinTypeADC(GPIO_PORTE_BASE, GPIO_PIN_3);
	// : gpADCV[PT̎w
	ADCSequenceConfigure(ADC0_BASE, 3, ADC_TRIGGER_PROCESSOR, 0);
	// : ADCV[PT̐ݒ
	ADCSequenceStepConfigure(ADC0_BASE, 3, 0, ADC_CTL_CH0 | ADC_CTL_IE | ADC_CTL_END);
	// : ADCV[PTLɂ
	ADCSequenceEnable(ADC0_BASE, 3);

	// PWM̐ݒ
	// : PE4(M0PWM4), PE5(M0PWM5)PWMɐݒ
	GPIOPinTypePWM(GPIO_PORTE_BASE, GPIO_PIN_4);
	GPIOPinTypePWM(GPIO_PORTE_BASE, GPIO_PIN_5);
	// : PE4M0PWM4, PE5M0PWMɐݒ
	GPIOPinConfigure(GPIO_PE4_M0PWM4);
	GPIOPinConfigure(GPIO_PE5_M0PWM5);
	// : PWM̎w@F 1ms
	ulPeriod = SysCtlClockGet() / 1000;
	// : PWMWFl[^̐ݒ
	PWMGenConfigure(PWM0_BASE, PWM_GEN_2, PWM_GEN_MODE_UP_DOWN | PWM_GEN_MODE_NO_SYNC);
	// : PWMWFl[^̎ݒ
	PWMGenPeriodSet(PWM0_BASE, PWM_GEN_2, ulPeriod);
	// : PWM̃f[eB̎w
	PWMPulseWidthSet(PWM0_BASE, PWM_OUT_4, ulPeriod * 9 / 10);
	PWMPulseWidthSet(PWM0_BASE, PWM_OUT_5, ulPeriod * 9 / 10);
	// : PWM4̏o͂, PWM5̏o͂s
	PWMOutputState(PWM0_BASE, PWM_OUT_4_BIT, true);
	PWMOutputState(PWM0_BASE, PWM_OUT_5_BIT, false);
	// : PWMJn
	PWMGenEnable(PWM0_BASE, PWM_GEN_2);

	while (1) {
		// A/DϊJn
		ADCProcessorTrigger(ADC0_BASE, 3);
		// A/Dϊl̎擾
		ADCSequenceDataGet(ADC0_BASE, 3, &data);
		// A/Dϊ̒lɉăf[eBύX
		PWMPulseWidthSet(PWM0_BASE, PWM_OUT_4, ulPeriod * data / 4096);
	}
}
