#include <stdint.h>
#include <stdbool.h>
#include "inc/hw_types.h"
#include "inc/hw_memmap.h"
#include "driverlib/gpio.h"
#include "driverlib/sysctl.h"

// LED_/p}N
#define ON	0x00
#define OFF 0xFF

// XCb`LED_
void main(void) {
	// NbN̐ݒ
	SysCtlClockSet(SYSCTL_SYSDIV_1 | SYSCTL_USE_OSC | SYSCTL_OSC_MAIN | SYSCTL_XTAL_16MHZ);

	// gpytF̗L
	// : LEDpIO|[gDgp
	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOD);
	// : XCb`pIO|[gBgp
	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOB);

	// PD0o̓^Cvɐݒ
	GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, GPIO_PIN_0);

	// PB2̓^Cvɐݒ
	GPIOPinTypeGPIOInput(GPIO_PORTB_BASE, GPIO_PIN_2);

	while (1) {
		// PSW1Ă邩
		if (GPIOPinRead(GPIO_PORTB_BASE, GPIO_PIN_2) == 0) {
			// LEDON
			GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_0, ON);
		} else {
			// LEDOFF
			GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_0, OFF);
		}
	}
}
