#include <stdint.h>
#include <stdbool.h>
#include "inc/hw_ints.h"
#include "inc/hw_types.h"
#include "inc/hw_memmap.h"
#include "driverlib/gpio.h"
#include "driverlib/sysctl.h"
#include "driverlib/interrupt.h"
#include "driverlib/timer.h"

// LED_/p}N
#define ON	0x00
#define OFF 0xFF
// LED_p^[pϐ
char State;

// 荞ݏ
void Timer0IntHandler(void) {
	// ^C}Zbg
	TimerIntClear(TIMER0_BASE, TIMER_TIMA_TIMEOUT);
	// rbg]
	State = ~State;
	// LEDON/OFFɂ
	GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_0, State);
}

// LEDIi1bjON/OFF 
void main(void) {
	// NbN̐ݒ
	SysCtlClockSet(SYSCTL_SYSDIV_1 | SYSCTL_USE_OSC | SYSCTL_OSC_MAIN | SYSCTL_XTAL_16MHZ);

	// gpytF̗L
	// : LEDpIO|[gDgp
	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOD);
	// : ^C}W[0gp
	SysCtlPeripheralEnable(SYSCTL_PERIPH_TIMER0);

	// PD0o̓^Cvɐݒ
	GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, GPIO_PIN_0);

	// ^C}̐ݒ
	// : ^C}W[0Full-width(32bit)̎JE^Ŏgp
	TimerConfigure(TIMER0_BASE, TIMER_CFG_PERIODIC);
	// : ^C}̊荞݂Ԋuݒ
	TimerLoadSet(TIMER0_BASE, TIMER_A, SysCtlClockGet());
	// : 荞ݎɌĂяoi֐jw
	TimerIntRegister(TIMER0_BASE, TIMER_A, Timer0IntHandler);
	// : 荞݂L
	IntEnable(INT_TIMER0A);
	// : ^CAEgł̊荞݂L
	TimerIntEnable(TIMER0_BASE, TIMER_TIMA_TIMEOUT);
	// : ^C}L
	TimerEnable(TIMER0_BASE, TIMER_A);
	State = OFF;
	// LEDOFFɂ
	GPIOPinWrite(GPIO_PORTD_BASE, GPIO_PIN_0, State);

	// [v
	while (1) {
	}
}
