#include <stdint.h>
#include <stdbool.h>
#include "inc/hw_types.h"
#include "inc/hw_memmap.h"
#include "driverlib/gpio.h"
#include "driverlib/sysctl.h"
#include "driverlib/adc.h"

// {[͂ɂ郌x[^
void main(void) {
	// A/Dϊli[p
	uint32_t data;
	// LED_p^[
	char State;
	// NbN̐ݒ
	SysCtlClockSet(SYSCTL_SYSDIV_1 | SYSCTL_USE_OSC | SYSCTL_OSC_MAIN |	SYSCTL_XTAL_16MHZ);

	// gpytF̗L
	// : LEDpIO|[gC, DAAiO͗pɃ|[gEgp
	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOC);
	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOD);
	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOE);
	// : A/DϊW[0gp
	SysCtlPeripheralEnable(SYSCTL_PERIPH_ADC0);

	// PD0~PD3,PC4`PC7o̓^Cvɐݒ
	GPIOPinTypeGPIOOutput(GPIO_PORTD_BASE, 0x0F);
	GPIOPinTypeGPIOOutput(GPIO_PORTC_BASE, 0xF0);

	// ADC̐ݒ
	// : PE3(AIN0)ADCɐݒ
	GPIOPinTypeADC(GPIO_PORTE_BASE, GPIO_PIN_3);
	// : gpADCV[PT̎w
	ADCSequenceConfigure(ADC0_BASE, 3, ADC_TRIGGER_PROCESSOR, 0);
	// : ADCV[PT̐ݒ
	ADCSequenceStepConfigure(ADC0_BASE, 3, 0, ADC_CTL_CH0 | ADC_CTL_IE | ADC_CTL_END);
	// : ADCV[PTLɂ
	ADCSequenceEnable(ADC0_BASE, 3);

	while (1) {
		// A/DϊJn
		ADCProcessorTrigger(ADC0_BASE, 3);
		// A/Dϊl̎擾
		ADCSequenceDataGet(ADC0_BASE, 3, &data);
		// A/Dlɂē_p^[ݒ
		if (data < 512) {
			// LED1_
			State = 0x01;
		} else if (data < 1024) {
			// LED2_
			State = 0x03;
		} else if (data < 1536) {
			// LED3_
			State = 0x07;
		} else if (data < 2048) {
			// LED4_
			State = 0x0F;
		} else if (data < 2560) {
			// LED5_
			State = 0x1F;
		} else if (data < 3072) {
			// LED6_
			State = 0x3F;
		} else if (data < 3584) {
			// LED7_
			State = 0x7F;
		} else {
			// LED8_
			State = 0xFF;
		}
		// LEDɓ_p^[o
		GPIOPinWrite(GPIO_PORTD_BASE, 0x0F, ~State);
		GPIOPinWrite(GPIO_PORTC_BASE, 0xF0, ~State);
	}
}
